diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/AUTHORS ns-3.41/AUTHORS
--- ns-3.40/AUTHORS	2023-09-27 13:30:37.522838800 -0700
+++ ns-3.41/AUTHORS	2024-02-09 14:44:07.717788700 -0800
@@ -27,10 +27,12 @@
 Pedro Bellotti (pedro177@gmail.com)
 Mehdi Benamor (mehdi.benamor@telecom-bretagne.eu)
 Apoorva Bhargava (apoorvabhargava13@gmail.com)
-Avakash Bhat(avakash261@gmail.com)
+Avakash Bhat (avakash261@gmail.com)
+Kavya Bhat (kavyabhat@gmail.com)
 Raj Bhattacharjea (raj.b@gatech.edu)
 Mathew Bielejeski (bielejeski1@llnl.gov)
 Timo Bingmann (timo.bingmann@student.kit.edu)
+Doug Blough (doug.blough@gatech.edu)
 Julien Boite (juboite@gmail.com)
 Biljana Bojovic (bbojovic@cttc.es)
 Elena Borovkova (borokovaes@iitp.ru)
@@ -42,6 +44,7 @@
 Jonathan Brugge (j.d.brugge@student.utwente.nl)
 Junling Bu (linlinjavaer@gmail.com)
 Elena Buchatskaia (borovkovaes@iitp.ru)
+Alessio Bugetti (alessiobugetti98@gmail.com)
 Nuno Cardoso (nunopcardoso@gmail.com)
 Gustavo Carneiro (gjc@inescporto.pt, gjcarneiro@gmail.com)
 Scott Carpenter (scarpen@ncsu.edu)
@@ -160,6 +163,7 @@
 Alexander Krotov (ilabdsf@yandex.ru)
 Deepak Kumaraswamy (deepakkavoor99@gmail.com)
 Mathieu Lacage (mathieu.lacage@inria.fr)
+Andrea Lacava (thecave003@gmail.com)
 Sandra Lagen (sandra.lagen@cttc.es)
 Emmanuelle Laprise (emmmanuelle.laprise@bluekazoo.ca)
 Harsh Lara (harshapplefan@gmail.com)
@@ -181,6 +185,7 @@
 Antti Makela (zarhan@cc.hut.fi)
 Francesco Malandrino (francesco.malandrino@gmail.com)
 Rubén Martínez (rmartinez@deic.uab.cat)
+Chaz Maschman
 Ryan Mast (mast9@llnl.gov)
 Fabian Mauchle (f1mauchl@hsr.ch)
 Mauriyin (haoyin@uw.edu)
@@ -188,6 +193,7 @@
 Jonathan McCrohan (jmccroha@tcd.ie)
 Andrew McGregor (andrewmcgr@gmail.com)
 Miralem Mehic (miralemmehic@gmail.com)
+Levente Mészáros (levy@omnetpp.org)
 Vedran Miletić (rivanvx@gmail.com)
 Saswat Mishra (clicksaswat@gmail.com)
 Jens Mittag (jens.mittag@kit.edu)
@@ -242,6 +248,7 @@
 Anna Poon (poon2@llnl.gov)
 Gauri Prasad
 Vikas Pushkar (vikaskupushkar@gmail.com)
+Martin Quinson (mquinson@debian.org)
 Philipp Raich (philipp.raich@tuwien.ac.at)
 Alberto Gallegos Ramonet (alramonet@is.tokushima-u.ac.jp)
 Manoj Kumar Rana (manoj24.rana@gmail.com)
@@ -327,6 +334,7 @@
 He Wu (mdzz@u.washington.edu)
 Xiuchao Wu (xiuchao@amazon.com)
 Aron Wussler (aron@wussler.it)
+Heran Yang (heran55@126.com)
 Yoshihiko Yazawa (yoshiyaz@gmail.com)
 Menglei Zhang (menglei@nyu.edu)
 Theodore Zhang (harryzwh@gmail.com)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/bindings/python/ns__init__.py ns-3.41/bindings/python/ns__init__.py
--- ns-3.40/bindings/python/ns__init__.py	2023-09-27 13:30:37.526838800 -0700
+++ ns-3.41/bindings/python/ns__init__.py	2024-02-09 14:44:07.721789000 -0800
@@ -1,10 +1,10 @@
 import builtins
-from functools import lru_cache
 import glob
 import os.path
+import re
 import sys
 import sysconfig
-import re
+from functools import lru_cache
 
 DEFAULT_INCLUDE_DIR = sysconfig.get_config_var("INCLUDEDIR")
 DEFAULT_LIB_DIR = sysconfig.get_config_var("LIBDIR")
@@ -14,7 +14,7 @@
     # Get the absolute path to this file
     path_to_this_init_file = os.path.dirname(os.path.abspath(__file__))
     path_to_lock = path_to_this_init_file
-    lock_file = (".lock-ns3_%s_build" % sys.platform)
+    lock_file = ".lock-ns3_%s_build" % sys.platform
 
     # Move upwards until we reach the directory with the ns3 script
     prev_path = None
@@ -32,15 +32,17 @@
     return path_to_lock
 
 
-SYSTEM_LIBRARY_DIRECTORIES = (DEFAULT_LIB_DIR,
-                              os.path.dirname(DEFAULT_LIB_DIR),
-                              "/usr/lib64",
-                              "/usr/lib"
-                              )
-DYNAMIC_LIBRARY_EXTENSIONS = {"linux": "so",
-                              "win32": "dll",
-                              "darwin": "dylib"
-                              }
+SYSTEM_LIBRARY_DIRECTORIES = (
+    DEFAULT_LIB_DIR,
+    os.path.dirname(DEFAULT_LIB_DIR),
+    "/usr/lib64",
+    "/usr/lib",
+)
+DYNAMIC_LIBRARY_EXTENSIONS = {
+    "linux": "so",
+    "win32": "dll",
+    "darwin": "dylib",
+}
 LIBRARY_EXTENSION = DYNAMIC_LIBRARY_EXTENSIONS[sys.platform]
 
 
@@ -76,8 +78,9 @@
     library_search_paths += [os.path.dirname(library_search_paths[-1])]
 
     # Filter unique search paths and those that are not part of system directories
-    library_search_paths = list(filter(lambda x: x not in SYSTEM_LIBRARY_DIRECTORIES,
-                                       set(library_search_paths)))
+    library_search_paths = list(
+        filter(lambda x: x not in SYSTEM_LIBRARY_DIRECTORIES, set(library_search_paths))
+    )
 
     # Search for the core library in the search paths
     libraries = []
@@ -88,7 +91,9 @@
     # Search system library directories (too slow for recursive search)
     for search_path in SYSTEM_LIBRARY_DIRECTORIES:
         if os.path.exists(search_path):
-            libraries += glob.glob("%s/**/*.%s*" % (search_path, LIBRARY_EXTENSION), recursive=False)
+            libraries += glob.glob(
+                "%s/**/*.%s*" % (search_path, LIBRARY_EXTENSION), recursive=False
+            )
             libraries += glob.glob("%s/*.%s*" % (search_path, LIBRARY_EXTENSION), recursive=False)
 
     del search_path, library_search_paths
@@ -106,7 +111,7 @@
         library_map[library_infix].add(library)
 
     # Replace sets with lists
-    for (key, values) in library_map.items():
+    for key, values in library_map.items():
         library_map[key] = list(values)
     return library_map
 
@@ -128,7 +133,7 @@
     "libxml2": ["HAVE_LIBXML2"],
     "libsqlite3": ["HAVE_SQLITE3"],
     "openflow": ["NS3_OPENFLOW", "ENABLE_OPENFLOW"],
-    "click": ["NS3_CLICK"]
+    "click": ["NS3_CLICK"],
 }
 
 
@@ -137,11 +142,11 @@
     defines = ""
     if len(has_defines):
         for define in LIBRARY_AND_DEFINES[has_defines[0]]:
-            defines += (f"""
+            defines += f"""
                     #ifndef {define}
                     #define {define} 1
                     #endif
-                """)
+                """
     return defines
 
 
@@ -156,10 +161,11 @@
     # First discover which 3rd-party libraries are used by the current module
     try:
         with open(os.path.abspath(library_path), "rb") as f:
-            linked_libs = re.findall(b"\x00(lib.*?.%b)" % LIBRARY_EXTENSION.encode("utf-8"), f.read())
+            linked_libs = re.findall(
+                b"\x00(lib.*?.%b)" % LIBRARY_EXTENSION.encode("utf-8"), f.read()
+            )
     except Exception as e:
-        print("Failed to extract libraries used by {library} with exception:{exception}"
-              .format(library=library_path, exception=e))
+        print(f"Failed to extract libraries used by {library_path} with exception:{e}")
         exit(-1)
     return library_path, lib, list(map(lambda x: x.decode("utf-8"), linked_libs))
 
@@ -182,8 +188,8 @@
         # Raise error in case the library can't be found
         if len(linked_library_path) == 0:
             raise Exception(
-                "Failed to find {library}. Make sure its library directory is in LD_LIBRARY_PATH.".format(
-                    library=linked_library))
+                f"Failed to find {linked_library}. Make sure its library directory is in LD_LIBRARY_PATH."
+            )
 
         # Get path with the shortest length
         linked_library_path = sorted(linked_library_path, key=lambda x: len(x))[0]
@@ -201,7 +207,9 @@
             linked_libs_include_dirs.add(system_include_dir)
 
             # If system_include_dir/library_name exists, we add it too
-            linked_library_name = linked_library.replace("lib", "").replace("." + LIBRARY_EXTENSION, "")
+            linked_library_name = linked_library.replace("lib", "").replace(
+                "." + LIBRARY_EXTENSION, ""
+            )
             if os.path.exists(os.path.join(system_include_dir, linked_library_name)):
                 linked_libs_include_dirs.add(os.path.join(system_include_dir, linked_library_name))
 
@@ -232,19 +240,26 @@
     suffix = "-" + values["BUILD_PROFILE"] if values["BUILD_PROFILE"] != "release" else ""
     modules = [module.replace("ns3-", "") for module in values["NS3_ENABLED_MODULES"]]
     prefix = values["out_dir"]
-    libraries = {os.path.splitext(os.path.basename(x))[0]: x for x in os.listdir(os.path.join(prefix, "lib"))}
+    libraries = {
+        os.path.splitext(os.path.basename(x))[0]: x for x in os.listdir(os.path.join(prefix, "lib"))
+    }
     version = values["VERSION"]
 
     # Filter out test libraries and incorrect versions
-    def filter_in_matching_ns3_libraries(libraries_to_filter: dict,
-                                         modules_to_filter: list,
-                                         version: str,
-                                         suffix: str) -> dict:
+    def filter_in_matching_ns3_libraries(
+        libraries_to_filter: dict,
+        modules_to_filter: list,
+        version: str,
+        suffix: str,
+    ) -> dict:
         suffix = [suffix[1:]] if len(suffix) > 1 else []
         filtered_in_modules = []
         for module in modules_to_filter:
-            filtered_in_modules += list(filter(lambda x: "-".join([version, module, *suffix]) in x,
-                                               libraries_to_filter.keys()))
+            filtered_in_modules += list(
+                filter(
+                    lambda x: "-".join([version, module, *suffix]) in x, libraries_to_filter.keys()
+                )
+            )
         for library in list(libraries_to_filter.keys()):
             if library not in filtered_in_modules:
                 libraries_to_filter.pop(library)
@@ -255,15 +270,11 @@
     # When we have the lock file, we assemble the correct library names
     libraries_to_load = []
     for module in modules:
-        library_name = "libns{version}-{module}{suffix}".format(
-            version=version,
-            module=module,
-            suffix=suffix
-        )
+        library_name = f"libns{version}-{module}{suffix}"
         if library_name not in libraries:
-            raise Exception("Missing library %s\n" % library_name,
-                            "Build all modules with './ns3 build'"
-                            )
+            raise Exception(
+                f"Missing library {library_name}\n", "Build all modules with './ns3 build'"
+            )
         libraries_to_load.append(libraries[library_name])
     return prefix, libraries_to_load, version
 
@@ -282,7 +293,14 @@
         components.pop(0)
 
     # Drop build profile suffix and test libraries
-    if components[-1] in ["debug", "default", "optimized", "release", "relwithdebinfo", "minsizerel"]:
+    if components[-1] in [
+        "debug",
+        "default",
+        "optimized",
+        "release",
+        "relwithdebinfo",
+        "minsizerel",
+    ]:
         components.pop(-1)
     return "-".join(components)
 
@@ -337,10 +355,14 @@
         # Filter out older ns-3 libraries
         for module in list(modules_to_filter):
             # Filter duplicates of modules, while excluding test libraries
-            conflicting_libraries = list(filter(lambda x: module == filter_module_name(x), libraries_to_filter))
+            conflicting_libraries = list(
+                filter(lambda x: module == filter_module_name(x), libraries_to_filter)
+            )
 
             # Extract versions from conflicting libraries
-            conflicting_libraries_versions = list(map(lambda x: extract_version(x, module), conflicting_libraries))
+            conflicting_libraries_versions = list(
+                map(lambda x: extract_version(x, module), conflicting_libraries)
+            )
 
             # Get the newest version found for that library
             newest_version = get_newest_version(conflicting_libraries_versions)
@@ -351,8 +373,9 @@
             else:
                 newest_version_found = get_newest_version([newest_version, newest_version_found])
                 if newest_version != newest_version_found:
-                    raise Exception("Incompatible versions of the ns-3 module '%s' were found: %s != %s."
-                                    % (module, newest_version, newest_version_found))
+                    raise Exception(
+                        f"Incompatible versions of the ns-3 module '{module}' were found: {newest_version} != {newest_version_found}."
+                    )
 
             for conflicting_library in list(conflicting_libraries):
                 if "-".join([newest_version, module]) not in conflicting_library:
@@ -360,8 +383,9 @@
                     conflicting_libraries.remove(conflicting_library)
 
             if len(conflicting_libraries) > 1:
-                raise Exception("There are multiple build profiles for module '%s'.\nDelete one to continue: %s"
-                                % (module, ", ".join(conflicting_libraries)))
+                raise Exception(
+                    f"There are multiple build profiles for module '{module}'.\nDelete one to continue: {', '.join(conflicting_libraries)}"
+                )
 
         return libraries_to_filter, newest_version_found
 
@@ -387,7 +411,9 @@
         libraries = list(map(lambda x: os.path.basename(x), libraries))
         for ns3_library in libraries:
             _, _, linked_libraries = extract_linked_libraries(ns3_library, prefix)
-            linked_libraries = list(filter(lambda x: "libns3" in x and ns3_library not in x, linked_libraries))
+            linked_libraries = list(
+                filter(lambda x: "libns3" in x and ns3_library not in x, linked_libraries)
+            )
             linked_libraries = list(map(lambda x: os.path.basename(x), linked_libraries))
             module_dependencies[os.path.basename(ns3_library)] = linked_libraries
 
@@ -404,19 +430,27 @@
                 modules.append(pending_module)
             return modules
 
-        def dependency_order(module_dependencies, pending_modules, current_modules, step_number=0, steps={}):
+        def dependency_order(
+            module_dependencies, pending_modules, current_modules, step_number=0, steps={}
+        ):
             if len(pending_modules) == 0:
                 return steps
             if step_number not in steps:
                 steps[step_number] = []
-            for module in modules_that_can_be_loaded(module_dependencies, pending_modules, current_modules):
+            for module in modules_that_can_be_loaded(
+                module_dependencies, pending_modules, current_modules
+            ):
                 steps[step_number].append(module)
                 pending_modules.remove(module)
                 current_modules.append(module)
-            return dependency_order(module_dependencies, pending_modules, current_modules, step_number + 1, steps)
+            return dependency_order(
+                module_dependencies, pending_modules, current_modules, step_number + 1, steps
+            )
 
         sorted_libraries = []
-        for step in dependency_order(module_dependencies, list(module_dependencies.keys()), [], 0).values():
+        for step in dependency_order(
+            module_dependencies, list(module_dependencies.keys()), [], 0
+        ).values():
             sorted_libraries.extend(step)
         return sorted_libraries
 
@@ -441,7 +475,8 @@
 
     # Register Ptr<> as a smart pointer
     import libcppyy
-    libcppyy.AddSmartPtrType('Ptr')
+
+    libcppyy.AddSmartPtrType("Ptr")
 
     # Import ns-3 libraries
     for variant in ["lib", "lib64"]:
@@ -479,7 +514,8 @@
         setattr(cppyy.gbl.ns3, module.replace("-", "_"), cppyy.gbl.ns3)
 
     # Set up a few tricks
-    cppyy.cppdef("""
+    cppyy.cppdef(
+        """
         using namespace ns3;
         bool Time_ge(Time& a, Time& b){ return a >= b;}
         bool Time_eq(Time& a, Time& b){ return a == b;}
@@ -487,7 +523,8 @@
         bool Time_le(Time& a, Time& b){ return a <= b;}
         bool Time_gt(Time& a, Time& b){ return a > b;}
         bool Time_lt(Time& a, Time& b){ return a < b;}
-    """)
+    """
+    )
     cppyy.gbl.ns3.Time.__ge__ = cppyy.gbl.Time_ge
     cppyy.gbl.ns3.Time.__eq__ = cppyy.gbl.Time_eq
     cppyy.gbl.ns3.Time.__ne__ = cppyy.gbl.Time_ne
@@ -508,7 +545,8 @@
 
     cppyy.gbl.ns3.Node.__del__ = Node_del
 
-    cppyy.cppdef("""
+    cppyy.cppdef(
+        """
         using namespace ns3;
         std::tuple<bool, TypeId> LookupByNameFailSafe(std::string name)
         {
@@ -516,44 +554,49 @@
             bool ok = TypeId::LookupByNameFailSafe(name, &id);
             return std::make_tuple(ok, id);
         }
-    """)
+    """
+    )
     setattr(cppyy.gbl.ns3, "LookupByNameFailSafe", cppyy.gbl.LookupByNameFailSafe)
 
     def CreateObject(className):
         try:
             try:
-                func = "CreateObject%s" % re.sub('[<|>]', '_', className)
+                func = "CreateObject%s" % re.sub("[<|>]", "_", className)
                 return getattr(cppyy.gbl, func)()
             except AttributeError:
                 pass
             try:
-                func = "Create%s" % re.sub('[<|>]', '_', className)
+                func = "Create%s" % re.sub("[<|>]", "_", className)
                 return getattr(cppyy.gbl, func)()
             except AttributeError:
                 pass
             raise AttributeError
         except AttributeError:
             try:
-                func = "CreateObject%s" % re.sub('[<|>]', '_', className)
-                cppyy.cppdef("""
+                func = "CreateObject%s" % re.sub("[<|>]", "_", className)
+                cppyy.cppdef(
+                    """
                             using namespace ns3;
                             Ptr<%s> %s(){
                                 Ptr<%s> object = CreateObject<%s>();
                                 return object;
                             }
-                            """ % (className, func, className, className)
-                             )
+                            """
+                    % (className, func, className, className)
+                )
             except Exception as e:
                 try:
-                    func = "Create%s" % re.sub('[<|>]', '_', className)
-                    cppyy.cppdef("""
+                    func = "Create%s" % re.sub("[<|>]", "_", className)
+                    cppyy.cppdef(
+                        """
                                 using namespace ns3;
                                 %s %s(){
                                     %s object = %s();
                                     return object;
                                 }
-                                """ % (className, func, className, className)
-                                 )
+                                """
+                        % (className, func, className, className)
+                    )
                 except Exception as e:
                     exit(-1)
         return getattr(cppyy.gbl, func)()
@@ -582,10 +625,12 @@
                {
                     return parentPtr->GetObject<%s>();
                }
-            """ % (aggregatedType, aggregatedType, aggregatedType, aggregatedType)
+            """
+            % (aggregatedType, aggregatedType, aggregatedType, aggregatedType)
+        )
+        return cppyy.gbl.getAggregatedObject(
+            parentObject, aggregatedObject if aggregatedIsClass else aggregatedObject.__class__
         )
-        return cppyy.gbl.getAggregatedObject(parentObject,
-                                             aggregatedObject if aggregatedIsClass else aggregatedObject.__class__)
 
     setattr(cppyy.gbl.ns3, "GetObject", GetObject)
     return cppyy.gbl.ns3
@@ -593,4 +638,4 @@
 
 # Load all modules and make them available via a built-in
 ns = load_modules()  # can be imported via 'from ns import ns'
-builtins.__dict__['ns'] = ns  # or be made widely available with 'from ns import *'
+builtins.__dict__["ns"] = ns  # or be made widely available with 'from ns import *'
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/3rd-party/colored-messages.cmake ns-3.41/build-support/3rd-party/colored-messages.cmake
--- ns-3.40/build-support/3rd-party/colored-messages.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/3rd-party/colored-messages.cmake	2024-02-09 14:44:07.721789000 -0800
@@ -24,21 +24,21 @@
 # cmake-format: on
 
 # Set empty values for colors
-set(ColourReset)
-set(Red)
-set(Green)
-set(Yellow)
-set(Blue)
-set(Magenta)
-set(Cyan)
-set(White)
-set(BoldRed)
-set(BoldGreen)
-set(BoldYellow)
-set(BoldBlue)
-set(BoldMagenta)
-set(BoldCyan)
-set(BoldWhite)
+set(ColourReset "")
+set(Red "")
+set(Green "")
+set(Yellow "")
+set(Blue "")
+set(Magenta "")
+set(Cyan "")
+set(White "")
+set(BoldRed "")
+set(BoldGreen "")
+set(BoldYellow "")
+set(BoldBlue "")
+set(BoldMagenta "")
+set(BoldCyan "")
+set(BoldWhite "")
 
 # Custom message types fallback when not colorized
 set(HIGHLIGHTED_STATUS STATUS)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/3rd-party/find-program-hints.cmake ns-3.41/build-support/3rd-party/find-program-hints.cmake
--- ns-3.40/build-support/3rd-party/find-program-hints.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/3rd-party/find-program-hints.cmake	2024-02-09 14:44:07.721789000 -0800
@@ -1,3 +1,4 @@
+disable_cmake_warnings()
 set(3RD_PARTY_FIND_PROGRAM_HINTS
     # find_program HINTS for Doxygen
     # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
@@ -18,3 +19,4 @@
     /Applications/Graphviz.app/Contents/MacOS
     /Applications/Utilities/Graphviz.app/Contents/MacOS
 )
+enable_cmake_warnings()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-check-dependencies.cmake ns-3.41/build-support/custom-modules/ns3-check-dependencies.cmake
--- ns-3.40/build-support/custom-modules/ns3-check-dependencies.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-check-dependencies.cmake	2024-02-09 14:44:07.721789000 -0800
@@ -0,0 +1,59 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# function used to search for package and program dependencies than store list
+# of missing dependencies in the list whose name is stored in missing_deps
+function(check_deps missing_deps)
+  set(multiValueArgs CMAKE_PACKAGES EXECUTABLES PYTHON_PACKAGES)
+  cmake_parse_arguments("DEPS" "" "" "${multiValueArgs}" ${ARGN})
+
+  set(local_missing_deps)
+  # Search for package dependencies
+  foreach(package ${DEPS_CMAKE_PACKAGES})
+    find_package(${package})
+    if(NOT ${${package}_FOUND})
+      list(APPEND local_missing_deps ${package})
+    endif()
+  endforeach()
+
+  # And for program dependencies
+  foreach(program ${DEPS_EXECUTABLES})
+    # CMake likes to cache find_* to speed things up, so we can't reuse names
+    # here or it won't check other dependencies
+    string(TOUPPER ${program} upper_${program})
+    mark_as_advanced(${upper_${program}})
+    find_program(
+      ${upper_${program}} ${program} HINTS ${3RD_PARTY_FIND_PROGRAM_HINTS}
+    )
+    if("${${upper_${program}}}" STREQUAL "${upper_${program}}-NOTFOUND")
+      list(APPEND local_missing_deps ${program})
+    endif()
+  endforeach()
+
+  foreach(package ${DEPS_PYTHON_PACKAGES})
+    execute_process(
+      COMMAND ${Python3_EXECUTABLE} -c "import ${package}"
+      RESULT_VARIABLE return_code OUTPUT_QUIET ERROR_QUIET
+    )
+    if(NOT (${return_code} EQUAL 0))
+      list(APPEND local_missing_deps ${package})
+    endif()
+  endforeach()
+
+  # Store list of missing dependencies in the parent scope
+  set(${missing_deps} ${local_missing_deps} PARENT_SCOPE)
+endfunction()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-cmake-package.cmake ns-3.41/build-support/custom-modules/ns3-cmake-package.cmake
--- ns-3.40/build-support/custom-modules/ns3-cmake-package.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/custom-modules/ns3-cmake-package.cmake	2024-02-09 14:44:07.721789000 -0800
@@ -15,6 +15,19 @@
 #
 # Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
 
+# Set RPATH not too need LD_LIBRARY_PATH after installing. Add the lib64 variant
+# to support all platforms, such as alma linux, used to build the manylinux pip
+# wheel.
+set(CMAKE_INSTALL_RPATH
+    "${CMAKE_INSTALL_PREFIX}/lib:$ORIGIN/:$ORIGIN/../lib:${CMAKE_INSTALL_PREFIX}/lib64:$ORIGIN/:$ORIGIN/../lib64"
+)
+
+# cmake-format: off
+# You are a wizard, Harry!
+# source: https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
+# cmake-format: on
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
 function(build_required_and_libs_lists module_name visibility libraries
          all_ns3_libraries
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-compiler-and-linker-support.cmake ns-3.41/build-support/custom-modules/ns3-compiler-and-linker-support.cmake
--- ns-3.40/build-support/custom-modules/ns3-compiler-and-linker-support.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-compiler-and-linker-support.cmake	2024-02-09 14:44:07.721789000 -0800
@@ -0,0 +1,128 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# Compiler-specific version checks and flag/feature setting should be done here
+
+# Identify compiler and check version
+set(below_minimum_msg "compiler is below the minimum required version")
+set(CLANG FALSE)
+if("${CMAKE_CXX_COMPILER_ID}" MATCHES "AppleClang")
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${AppleClang_MinVersion})
+    message(
+      FATAL_ERROR
+        "Apple Clang ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${AppleClang_MinVersion}"
+    )
+  endif()
+  set(CLANG TRUE)
+endif()
+
+if((NOT CLANG) AND ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang"))
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${Clang_MinVersion})
+    message(
+      FATAL_ERROR
+        "Clang ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${Clang_MinVersion}"
+    )
+  endif()
+  set(CLANG TRUE)
+endif()
+
+if(CLANG)
+  if(${NS3_COLORED_OUTPUT} OR "$ENV{CLICOLOR}")
+    add_definitions(-fcolor-diagnostics) # colorize clang++ output
+  endif()
+endif()
+
+set(GCC FALSE)
+if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
+  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${GNU_MinVersion})
+    message(
+      FATAL_ERROR
+        "GNU ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${GNU_MinVersion}"
+    )
+  endif()
+  if((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "12.2.0"))
+    # PCH causes weird errors on certain versions of GCC when C++20 is enabled
+    # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=106799
+    set(NS3_PRECOMPILE_HEADERS OFF
+        CACHE BOOL "Precompile module headers to speed up compilation" FORCE
+    )
+  endif()
+  if((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "12.1.0")
+     AND (CMAKE_CXX_COMPILER_VERSION VERSION_LESS "12.3.2")
+  )
+    # Disable warnings-as-errors for certain versions of GCC when C++20 is
+    # enabled https://gcc.gnu.org/bugzilla/show_bug.cgi?id=105545
+    add_compile_options(-Wno-restrict)
+  endif()
+  set(GCC TRUE)
+  add_definitions(-fno-semantic-interposition)
+  if(${NS3_COLORED_OUTPUT} OR "$ENV{CLICOLOR}")
+    add_definitions(-fdiagnostics-color=always) # colorize g++ output
+  endif()
+endif()
+unset(below_minimum_msg)
+
+set(LIB_AS_NEEDED_PRE "")
+set(LIB_AS_NEEDED_POST "")
+set(STATIC_LINK_FLAGS -static -static-libstdc++ -static-libgcc)
+if(${GCC} AND NOT APPLE)
+  # using GCC
+  set(LIB_AS_NEEDED_PRE -Wl,--no-as-needed)
+  set(LIB_AS_NEEDED_POST -Wl,--as-needed)
+  set(LIB_AS_NEEDED_PRE_STATIC -Wl,--whole-archive,-Bstatic)
+  set(LIB_AS_NEEDED_POST_STATIC -Wl,--no-whole-archive)
+  set(LIB_AS_NEEDED_POST_STATIC_DYN -Wl,-Bdynamic,--no-whole-archive)
+endif()
+
+if(${CLANG} AND APPLE)
+  # using Clang set(LIB_AS_NEEDED_PRE -all_load)
+  set(LIB_AS_NEEDED_POST "")
+  set(LIB_AS_NEEDED_PRE_STATIC -Wl,-all_load)
+  set(STATIC_LINK_FLAGS "")
+endif()
+
+if(${NS3_FAST_LINKERS})
+  # Search for faster linkers mold and lld, and use them if available
+  mark_as_advanced(MOLD LLD)
+  find_program(MOLD mold)
+  find_program(LLD ld.lld)
+
+  # USING_FAST_LINKER will be defined if a fast linker is being used and its
+  # content will correspond to the fast linker name
+
+  # Mold support was added in GCC 12.1.0
+  if(NOT USING_FAST_LINKER
+     AND NOT (${MOLD} STREQUAL "MOLD-NOTFOUND")
+     AND LINUX
+     AND ${GCC}
+     AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 12.1.0)
+  )
+    set(USING_FAST_LINKER MOLD)
+    add_link_options("-fuse-ld=mold")
+  endif()
+
+  if(NOT USING_FAST_LINKER AND NOT (${LLD} STREQUAL "LLD-NOTFOUND")
+     AND (${GCC} OR ${CLANG})
+  )
+    set(USING_FAST_LINKER LLD)
+    add_link_options("-fuse-ld=lld")
+    if(WIN32)
+      # Clear unsupported linker flags on Windows
+      set(LIB_AS_NEEDED_PRE "")
+    endif()
+  endif()
+endif()
